const path = require('path');
const requireIndex = require('requireindex');
const fs = require('fs');

let routes;

try {
  routes = requireIndex(path.join(process.cwd(), 'src', 'routes')) || requireIndex(path.join(__dirname));
} catch (e) {
  console.log(e);
}

const checkExists = (filePath) => {
  try {
    fs.accessSync(filePath, fs.F_OK);
    return fs.readFileSync(filePath);
  } catch (e) {
    return '';
  }
};

console.log(routes);

module.exports = (req, res) => {
  let rt = routes[`${req.url.split('/').pop()}`];
  const staticRes = checkExists(path.join(process.cwd(), 'public', req.url));
  if (req.url === '/') {
    rt = routes.home;
  }
  if (typeof rt === 'function') {
    rt(req, res);
  } else if (staticRes !== '') {
    res.end(staticRes);
  } else {
    routes.notfound(req, res);
  }
};
